<?php

/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* Modified by Joe Miner March 3, 2003                                  */
/*   Added support for NSN Groups. Users only see those modules to which*/
/*   they have access. Admin continues to see all modules.              */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
/* NSN Groups                                           */
/* By: NukeScripts Network (webmaster@nukescripts.net)  */
/* http://www.nukescripts.net                           */
/* Copyright  2000-2004 by NukeScripts Network         */
/********************************************************/

if (eregi("block-Modules.php", $_SERVER['PHP_SELF'])) {
    Header("Location: ../index.php");
    die();
}

require_once("mainfile.php");  // Added for NSN Groups checking
global $prefix, $db, $admin, $user; // Added $user for NSN Groups

$ThemeSel = get_theme();
if (file_exists("themes/$ThemeSel/module.php")) {
    include("themes/$ThemeSel/module.php");
    if (is_active("$default_module") AND file_exists("modules/$default_module/index.php")) {
        $def_module = $default_module;
    } else {
        $def_module = "";
    }
}

$result = $db->sql_query("select main_module from ".$prefix."_main");
list($main_module) = $db->sql_fetchrow($result);

/* If the module doesn't exist, it will be removed from the database automaticaly */

$result = $db->sql_query("select title from ".$prefix."_modules");
while (list($title) = $db->sql_fetchrow($result)) {
    $a = 0;
    $handle=opendir('modules');
    while ($file = readdir($handle)) {
        if ($file == $title) {
            $a = 1;
        }
    }
    closedir($handle);
    if ($a == 0) {
        $db->sql_query("delete from ".$prefix."_modules where title='$title'");
    }
}

/* Now we make the Modules block with the correspondent links */

$content .= "<strong><big></big></strong><a href=\"index.php\">"._HOME."</a><br>\n";
$result = $db->sql_query("SELECT title, custom_title, view FROM ".$prefix."_modules WHERE active='1' AND title!='$def_module' AND inmenu='1' ORDER BY custom_title ASC");
while(list($m_title, $custom_title, $view) = $db->sql_fetchrow($result)) {
    $m_title2 = ereg_replace("_", " ", $m_title);
    if ($custom_title != "") {
        $m_title2 = $custom_title;
    }
    if ($m_title != $main_module) {
        /* Beginning of NSN Groups Modification by J Miner, March 2003 */
        /* Decide if link gets shown based on group access             */
        $showit = 0;
        switch($view){
            case 0: // All users case
                $showit = 10;
            break;

            case 1: // Registered user access
                if (is_user($user) || is_admin($admin)) $showit = 1;
            break;

            case 2: // Admin only access
                if (is_admin($admin)) $showit = 2;
            break;

            default:  // Check if member of group that has access
                $newview = $view - 2;
                if (in_group($newview)) $showit = $view;
            break;
        }
        if ($showit != 0) {
        $content .= "<strong><big></big></strong><a href=\"modules.php?name=$m_title\">$m_title2</a><br>\n"; }
        /* End of NSN Groups Modification */
    }
}

/* If you're Admin you and only you can see Inactive modules and test it */
/* If you copied a new module is the /modules/ directory, it will be added to the database */

if (is_admin($admin)) {
    $handle=opendir('modules');
    while ($file = readdir($handle)) {
        if ( (!ereg("[.]",$file)) ) {
            $modlist .= "$file ";
        }
    }
    closedir($handle);
    $modlist = explode(" ", $modlist);
    sort($modlist);
    for ($i=0; $i < sizeof($modlist); $i++) {
        if($modlist[$i] != "") {
            $result = $db->sql_query("select mid from ".$prefix."_modules where title='$modlist[$i]'");
            list ($mid) = $db->sql_fetchrow($result);
            if ($mid == "") {
                $db->sql_query("insert into ".$prefix."_modules values (NULL, '$modlist[$i]', '$modlist[$i]', '0', '0', '1', '0')");
            }
        }
    }
    $content .= "<br><center><b>"._INVISIBLEMODULES."</b><br>";
    $content .= "<font class=\"tiny\">"._ACTIVEBUTNOTSEE."</font></center><br>";
    $result = $db->sql_query("select title, custom_title from ".$prefix."_modules where active='1' AND inmenu='0' ORDER BY title ASC");
    while(list($mn_title, $custom_title) = $db->sql_fetchrow($result)) {
        $mn_title2 = ereg_replace("_", " ", $mn_title);
        if ($custom_title != "") {
            $mn_title2 = $custom_title;
        }
        if ($mn_title2 != "") {
            $content .= "<strong><big></big></strong><a href=\"modules.php?name=$mn_title\">$mn_title2</a><br>\n";
            $dummy = 1;
        } else {
            $a = 1;
        }
    }
    if ($a == 1 AND $dummy != 1) {
        $content .= "<strong><big></big></strong><i>"._NONE."</i><br>\n";
    }
    $content .= "<br><center><b>"._NOACTIVEMODULES."</b><br>";
    $content .= "<font class=\"tiny\">"._FORADMINTESTS."</font></center><br>";
    $result = $db->sql_query("select title, custom_title from ".$prefix."_modules where active='0' ORDER BY title ASC");
    while(list($mn_title, $custom_title) = $db->sql_fetchrow($result)) {
        $mn_title2 = ereg_replace("_", " ", $mn_title);
        if ($custom_title != "") {
            $mn_title2 = $custom_title;
        }
        if ($mn_title2 != "") {
            $content .= "<strong><big></big></strong><a href=\"modules.php?name=$mn_title\">$mn_title2</a><br>\n";
            $dummy = 1;
        } else {
            $a = 1;
        }
    }
    if ($a == 1 AND $dummy != 1) {
        $content .= "<strong><big></big></strong><i>"._NONE."</i><br>\n";
    }
}

?>
